import javax.swing.*;
import javax.swing.border.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;

/** */
public class PropertyDialog extends Dialog implements ActionListener,ItemListener{

	TextField name = new TextField(16);
	TextField email = new TextField(16);
	TextField color = new TextField(3);
	TextField reftime = new TextField(3);
	TextField home = new TextField(32);
	Checkbox proxy = new Checkbox("Use Proxy");
	TextField host = new TextField(16);
	TextField port = new TextField(5);
	PropertyFile property;

	/** */
	public PropertyDialog(Frame owner) {
		super(owner,"ݒ",true);
	}

	/** */
    public PropertyDialog(Frame owner,PropertyFile property) {
		this(owner);
		this.property = property;

		proxy.addItemListener(this);
		name.setText(property.getProperty("name"));
		color.setText(property.getProperty("color"));
		reftime.setText(property.getProperty("reftime"));
		email.setText(property.getProperty("email"));
		home.setText(property.getProperty("home"));

		setProxy();
		buildDialog();
		pack();
	}

	/** */
	private void setProxy(boolean sw){
		if(sw){
			property.setProperty("proxySet","true");
		}else{
			property.setProperty("proxySet","false");
		}
		setProxy();
	}

	/** */
	private void setProxy(){
		String s = property.getProperty("proxySet");
		String h = property.getProperty("proxyHost");
		String p = property.getProperty("proxyPort");
		if(s == null) s = "false";
		if(h == null) h = "";
		if(p == null) p = "";
		boolean sw = s.equals("true");
		proxy.setState(sw);
		host.setEnabled(sw);
		port.setEnabled(sw);
		host.setText(h);
		port.setText(p);
	}

	/** */
	public void buildDialog(){
		Panel control1 = new Panel(new FlowLayout(FlowLayout.LEFT));
		Panel control2 = new Panel(new FlowLayout(FlowLayout.LEFT));
		Panel control3 = new Panel(new FlowLayout(FlowLayout.LEFT));
		Panel control4 = new Panel(new FlowLayout(FlowLayout.LEFT));
		Panel control5 = new Panel(new FlowLayout(FlowLayout.LEFT));
		Panel control6 = new Panel(new FlowLayout(FlowLayout.CENTER));

		Button okButton = new Button("OK");
		Button cancelButton = new Button("Cancel");

		okButton.addActionListener(this);
		cancelButton.addActionListener(this);

		control1.add(new Label("Name:",Label.RIGHT));
		control1.add(name);
		control1.add(new Label("Color:",Label.RIGHT));
		control1.add(color);
		control2.add(new Label("E-Mail:",Label.RIGHT));
		control2.add(email);
		control2.add(new Label("RefTime:",Label.RIGHT));
		control2.add(reftime);
		control3.add(new Label("Home:",Label.RIGHT));
		control3.add(home);
		control4.add(proxy);
		control5.add(new Label("Host:",Label.RIGHT));
		control5.add(host);
		control5.add(new Label("Port:",Label.RIGHT));
		control5.add(port);
		control6.add(okButton);
		control6.add(cancelButton);

		this.setLayout(new GridLayout(6,1,0,0));
		this.add(control1);
		this.add(control2);
		this.add(control3);
		this.add(control4);
		this.add(control5);
		this.add(control6);
	}

	/** */
	public void actionPerformed(ActionEvent e){
		String command = e.getActionCommand();
		System.out.println(command);

		if(command.equals("OK")){
			property.setProperty("name",name.getText());
			property.setProperty("color",color.getText());
			property.setProperty("reftime",reftime.getText());
			property.setProperty("email",email.getText());
			property.setProperty("home",home.getText());
			Properties sysProperties = System.getProperties();
			if(proxy.getState()){
				property.setProperty("proxySet","true");
				sysProperties.put("proxySet","true");
			}else{
				property.setProperty("proxySet","false");
				sysProperties.put("proxySet","false");
			}
			property.setProperty("proxyHost",host.getText());
			property.setProperty("proxyPort",port.getText());
			sysProperties.put("proxyHost",host.getText());
			sysProperties.put("proxyPort",port.getText());
			property.saveProperty(null);
			setVisible(false);
		}

		if(command.equals("Cancel")){
			setVisible(false);
		}
	}

	/** */
	public void itemStateChanged(ItemEvent e){
		if(e.getItemSelectable() == proxy){
			if(e.getStateChange() == ItemEvent.SELECTED) setProxy(true);
			if(e.getStateChange() == ItemEvent.DESELECTED) setProxy(false);
		}
	}

	/** */
	public static void main(String argv[]){
		PropertyDialog chibiFrame = new PropertyDialog(new JFrame(),PropertyFile.getInstance("Chibi.properties"));
		chibiFrame.setVisible(true);
	}
}
